!> \file paradim-ant15_CISM_mod.f90
!! Def des dimensions du grille CISM a 15 km  
!<

!> \namespace module_ant15_CISM
!! Def des dimensions du grille CISM a 15 km  
!! \author ...
!! \date ...
!! @note prescribe nx,ny,  dimension of most arrays
!! for Antarctic 15 km grid CISM
!<

module module_ant15_CISM

implicit none

! character
character(len=7),  parameter  ::  geoplace='CISMA15'
character(len=23), parameter  :: dirnameinp='../INPUT/ANT-CISM-15km/' !< input directory
character(len=17), parameter  :: dirforcage='../INPUT/Forcage/' !< input directory

! dimensionnement grilles
!-------------------------
integer, parameter :: nx=400           !< dimension selon x (indice i)
integer, parameter :: ny=400           !< dimension selon y (indice j)
integer, parameter :: nlmin=400        !< min(nx,ny), pour matrice elliptique  
integer, parameter :: nz=21            !< dimension selon z (indice k) 
integer, parameter :: nzm=4            !< nb de points verticaux dans le socle
integer, parameter :: nn=199           !< pour des sorties


! pas horizontal
!-----------------
real, parameter    :: dx=15000.0      !< pas en X en m
real, parameter    :: dy=15000.0      !< pas en Y en m


end module module_ant15_CISM
