!> \file module_choix-eurasie-0.4.f90
!! Ce module permet de choisir quels package on veut utiliser
!! 
!<

!> \namespace MODULE_CHOIX
!! Ce module permet de choisir quels package on veut utiliser
!! \author CatRitz
!! \date ...
!! @note Used modules
!! @note   - use use lect_topo_eurasie   
!! @note   - use climat_forcage_mois_mod
!! @note   - use lakes_prescribed_mod
!! @note   - use isostasie_mod  
!! @note   - use deformation_mod 
!! @note   - use  prop_thermiques_ice
!! @note   - use eau_basale
!! @note   - use sliding_Bindschadler 
!! @note   - use dragging_hwat_contmaj
!! @note   - use eq_ellip_sgbsv_mod
!! @note   - use calving_frange
!! @note   - use equat_adv_diff_2D       
!! @note   - use bmelt_eurasie_regions
!! @note   - use fake_eurasie
!! @note   - use out_profile  
!! @note   - use out_cptr     
!! @note   - use out_hz       
!! @note   - use output_eurasie40_mod
!! @note   - use printtable
!<


MODULE MODULE_CHOIX

!--------------Lecture topo ------------------------
!use lect_topo_anteis    ! pour l'antarctique 40 km
!use lect_topo_nord40    ! pour l'hemisphere nord 40 km
 use lect_topo_eurasie   ! pour l'eurasie  (toute resolutions)

!--------------Lecture climat ref ------------------
! use lect_clim_act_anteis
! use lect_clim_act_nord40   ! pour l'hemisphere nord 
! use lect_clim_act_eurasie ! pour l'eurasie

!--------------Lecture climat forcage---------------
! use climat_perturb_mod
! use climat_forcage_mod
! use climat_forcage_eurasie_mod
! use climat_forcage_stat_mois_mod
use climat_forcage_mois_mod
! use climat_synthes_mod
! use climat_profil_mod

! lacs proglaciaires
use lakes_prescribed_mod

!--------------Choix isostasie----------------------
 use isostasie_mod  ! module permettant de calculer la deflexion isostasique
! USE NOISOSTASIE_MOD ! module pour ne pas avoir d'isostasie

!--------------Module Physique---------------------
use deformation_mod  ! module concernant les lois de deformation

!--------------Module propritete thermique de la glace
use  prop_thermiques_ice
! use prop_therm_ice_heino

! eau basale
use eau_basale

! sliding- dragging
! use module sliding_vitbal
use sliding_Bindschadler
! use sliding_dragging_heino    ! loi de glissement heino : mis dans diffusiv : 


!use dragging_vitbil
! use dragging_hwatstream

!use dragging_hwat_cont

use dragging_hwat_contmaj

! use eq_elliptique_mod ! ancienne version (remplimat-5)
use eq_ellip_sgbsv_mod ! nouvelle version juillet 2008

! calving
!use calving_vincent ! ancienne version
use calving_frange


! choix resolution de la conservation de la masse
!-----------------------------------------------
use equat_adv_diff_2D          ! conservation masse avec advection-diffusion

!--------------Fusion basale------------------------
!use bmelt_ant_regions ! pour l'Antarctique avec rgions
 use bmelt_eurasie_regions ! pour l'Eurasie avec rgions

! fake -------fausses routines pour compatibilits
! use fake_heino
use fake_eurasie
! use fake_nord
!-------------- Outputs-----------------------------
!
use out_profile  !profils
!use out_cptr     ! fichier de reprise 
use out_hz       ! module de sorties snapshot dans un plan horizontal

!-----Suivi temporel
! use output_heminord_mod
use output_eurasie40_mod

!-----debugage...
use printtable


END MODULE MODULE_CHOIX
