!> \file prop-therm-Heino_mod.f90
!! Module qui definit les proprietes thermiques de la glace 
!<

!> \namespace  prop_therm_ice_heino
!! Dfinit les proprietes thermiques de la glace
!! \author ...
!! \date ...
!! @note Used module
!! @note   - use module3D_phy
!<

module prop_therm_ice_heino


! dfini les proprietes thermiques de la glace
! bloc qui tait avant dans icetemp


use module3D_phy

contains
subroutine thermal_prop


do k=1,nz  
  do j=1,ny
    do i=1,nx

!  temperature de fusion:TPMP (en deg C)
!  capacite calorifique : CP en J/Kg/K puis multiplie par ro en J/m3/K
!  conductivite : CT  en J/m/K/an
!   Attention pour la conductivite c'est la formule de Yin-Chao Yen


       tpmp(i,j,k)=-0.00087*(k-1)*de*h(i,j)
       cp(i,j,k)=2009.*ro ! en J/m3/K
!       ct(i,j,k)=6.627e7 !en J/m/K/an
       ct(i,j,k)=2.1*secyear
 
       end do
    end do
 end do

end subroutine thermal_prop
end module prop_therm_ice_heino
